import fetch from "flumm-fetch-cookies";
import config from "../config.mjs";
import user from "../user.mjs";

const api = `http://ws.audioscrobbler.com/2.0/?method=user.getRecentTracks&limit=1&api_key=${config.apis.lastfm.key}&format=json&user=`;

export default async bot => {

  return [{
    name: "lastfm",
    call: /^(\.|\/)np/i,
    set: "uwe",
    /*help: {
      text: "",
      usage: "[b].np[/b] [i]<user>[/i]"
    },*/
    f: async e => {
      if(e.args.length > 0 && e.args[0].charAt(0) === "=") {
        const tmp = e.args[0].slice(1);
        await user.set(e.user.prefix, { lastfm: tmp });
        return e.reply(`lastfm account set to: [b]${tmp}[/b]`);
      }

      if(!user.has(e.user.prefix))
        return e.reply("nope");
      const u = user.get(e.user.prefix);
      if(u.lastfm === null || u.lastfm === "")
        return e.reply("set up an account first: .np =username");
      
      const res = await (await fetch(`${api}${u.lastfm}`)).json();
      if(res.error)
        return e.reply("User not found");

      const info = {
        user: e.user.nick, //res["@attr"].user,
        track: `${res.recenttracks.track[0].artist["#text"]} - ${res.recenttracks.track[0].name}`,
        playing: !!res.recenttracks.track[0]["@attr"]
      };

      return e.reply(info.playing ?
        `[b]${info.user}[/b] is listening to [b]${info.track}[/b]` :
        `[b]${info.user}[/b] is not listening to anything. They last listened to [b]${info.track}[/b]`);
    }
  }];
};
