import fetch from "flumm-fetch-cookies";

const baseurl = "https://launchermeta.mojang.com/mc/game/version_manifest.json";
const jfcapi = "https://sky.matcool.site/api/upcomingEvents";
const jfctypes = [
  "Cactus", "Carrot", "Cocoa Beans", "Melon",
  "Mushroom", "Nether Wart", "Potato", "Pumpkin",
  "Sugar Cane", "Wheat"
];

export default async bot => {
  return [{
    name: "mcversion",
    call: /^(\.|\/)mcv$/i,
    f: async e => {
      const res = await (await fetch(baseurl)).json();
      const latest = {
        release:  res.versions.filter(a => a.id === res.latest.release)[0],
        snapshot: res.versions.filter(a => a.id === res.latest.snapshot)[0]
      };

      e.reply([
        `Release:  [b]${latest.release.id}[/b] (${new Date(latest.release.releaseTime).toLocaleString()})`,
        `Snapshot: [b]${latest.snapshot.id}[/b] (${new Date(latest.snapshot.releaseTime).toLocaleString()})`
      ]);
    }
  }, {
    name: "jfc",
    call: /^(\.|\/)jfc$/i,
    f: async e => {
      const res = (await (await fetch(jfcapi)).json()).slice(0, 3);
      e.reply([
        "Upcoming Events:",
        res.map(f => `time: in ${(f.timestamp - (new Date()).getTime())} seconds; crops: ${f.crops.map(g => jfctypes[g])}`).join("\n")
      ]);
    }
  }]
};
