import { maxoutput, sandbox, bfgen } from "./lib/sandbox.mjs";
import user from "../user.mjs";

import vm from "vm";
import util from "util";
import fetch from "flumm-fetch-cookies";
import serialize from "./lib/serialize.mjs";

let _contexts = new Map();

export default async bot => {
  if(user.size > 0)
    user.forEach((v, prefix) => eval(`_contexts.set(prefix, serialize.unserialize(v.sandbox));`));

  return [{
    name: "sandbox_js",
    call: /^(\.|\/)js (.*)/i,
    set: "uwe",
    active: false,
    f: async e => {
      const args = e.message.trim().substring(4);

      if (!_contexts.has(e.user.prefix))
        _contexts.set(e.user.prefix, vm.createContext({ }));
      if (args.match(/^reset$/)) {
        _contexts.set(e.user.prefix, vm.createContext({ }));
        await user.set(e.user.prefix, { sandbox: "{}" });
        return e.reply("Sandbox resetted!");
      }
      let context = vm.createContext(_contexts.get(e.user.prefix));

      try {
        let output = vm.runInContext(args, context, { timeout: 2000 });
        if (typeof output !== undefined && output) {
          output = util.inspect(output);
          if (output.length > maxoutput)
            return e.reply(`${e.user.nick}: holy fuck, Ausgabe wäre viel zu lang! (${output.length} Zeichen :DDDDDD)`);
          else {
            _contexts.set(e.user.prefix, context);
            await user.set(e.user.prefix, { sandbox: serialize.serialize(_contexts.get(e.user.prefix)) });
            e.reply(`${e.user.nick}: ${output}`);
          }
        }
        else
          e.reply("false lol");
      }
      catch (err) {
        e.reply(e.user.nick + ": " + err.message.length > maxoutput ? `holy fuck, Error wäre viel zu lang! (${err.message.length} Zeichen :DDDDDD)` : JSON.stringify(err.message));
      }
    }
  }, {
    name: "sandbox",
    call: /^\!(hs|py|cpp|bf|php|lua|bash) .*/i,
    set: "uwe",
    f: e => {
      let args = e.message.trim().substring(1).split(" ");
      const lang = args.shift();
      args = args.join(" ");

      sandbox(lang, args).then(
        resolve => e.reply(`${e.user.nick}: ${resolve}`),
        reject => e.reply(reject.replace("\n", " "))
      );
    }
  }, {
    name: "sandbox_rs",
    call: /^\!rs (.*)/i,
    set: "uwe",
    f: e => {
      const args = e.message.substring(4);
      const params = {
        channel: "stable",
        code: "fn main() { " + args + " }",
        crateType: "bin",
        mode: "debug",
        tests: false
      };
      const options = {
        method: "POST",
        body: params
      };

      fetch("https://play.rust-lang.org/execute", options)
        .then(res => res.json())
        .then(body => {
          e.reply(e.user.nick + ": " + body.success ? (body.stdout.length > maxoutput ? `holy fuck, Ausgabe wäre viel zu lang! (${body.stdout.length} Zeichen :DDDDDD)` : body.stdout) : "error!");
        }).catch(err => e.reply(err));
    }
  }, {
    name: "bfgen",
    call: /^\!bfgen .*/i,
    set: "uwe",
    f: e => {
      let args = e.message.trim().substring(7);
      let output = bfgen(args);
      e.reply(e.user.nick + ": " + output.length > maxoutput ? `holy fuck, Ausgabe wäre viel zu lang! (${output.length} Zeichen :DDDDDD)` : output);
    }
  }];
};
