import fetch from "flumm-fetch-cookies";

export default async bot => {
  
  return [{
    name: "ttc_search",
    call: /^(\.|\/)ttc/i,
    active: true,
    f: async e => {
      let results = await (await fetch(`https://eu.tamrieltradecentre.com/pc/Trade/SearchResult?ItemNamePattern=${e.args.join(" ")}`)).text();
      results = results.replace(/(\n|\r|\t)/g, '').replace(/\s{2,}/g, ' ');

      let list = results.match(/<tr class=\"cursor-pointer\" data-on-click-link=\"(.*?)<\/tr>/gsm);
      if(!list)
        return e.reply("nope");
      try {
        const items = list.map(l => {
          const n = l.match(/<div class=\"item-quality-epic\">(?<name>.*?)<\/div>/gsm)?.[0].replace(/<.*>(.*?)<\/div>/, "$1").trim();
          const m = l.match(/<div>(.*?)<\/div>/gsm);
          const level = +m[0].replace(/.*> (\d+?)<.*/, "$1").trim();
          const region = m[1].replace(/(<div>|<\/div>)/g, '').replace(/&#(\d+);/gi, (_, num) => String.fromCharCode(+num, 10)).trim().replace(/\n/g, '');
          const guild = m[2].replace(/(<div>|<\/div>)/g, '').trim();
          const price = l.match(/gold\.png\" \/>(.*?)<div/gsm)[0].replace(/.*>(.*?)<.*/, "$1").trim();
          return {
            name: n ?? e.args.join(" "),
            level: level,
            region: region,
            guild: guild,
            price: price
          };
        });
        return e.reply(
          items.slice(0, 3).map(f => `${f.name}: ${f.region} ${f.guild} - ${f.price} gold`)
        );
      } catch(err) {
        return e.reply(err);
      }
    }
  }];
};
